// ̃\[XR[h blanco Frameworkɂ莩܂B
using System;

namespace blanco.sample.stringconverter
{
    /// <summary>pJ^JiSpJ^Ji̕ϊ̃TvBblancoStringConverter̎ɂ͉e܂B</summary>
    public class SampleKatakanaHan2ZenStringConverter
    {
        /// <summary>u`B</summary>
        public static readonly string[][] STRING_CONVERT_DEF = new string[][] {new string[] { "", "B" }/* No.2 :a1: Ǔ_BSpJ^Jił͂ȂlɕϊB */, new string[] { "", "u" }/* No.3 :a2: p̃JMJbRBSpJ^Jił͂ȂlɕϊB */, new string[] { "", "v" }/* No.4 :a3: p̃JMJbRBSpJ^Jił͂ȂlɕϊB */, new string[] { "", "A" }/* No.5 :a4: Ǔ_BSpJ^Jił͂ȂlɕϊB */, new string[] { "", "E" }/* No.6 :a5: p̒BSpJ^Jił͂ȂlɕϊB */, new string[] { "", "" }/* No.8 :ɒ`܂B */, new string[] { "", "K" }/* No.9 :ɒ`܂B */, new string[] { "", "M" }/* No.10 :ɒ`܂B */, new string[] { "", "O" }/* No.11 :ɒ`܂B */, new string[] { "", "Q" }/* No.12 :ɒ`܂B */, new string[] { "", "S" }/* No.13 :ɒ`܂B */, new string[] { "", "U" }/* No.14 :ɒ`܂B */, new string[] { "", "W" }/* No.15 :ɒ`܂B */, new string[] { "", "Y" }/* No.16 :ɒ`܂B */, new string[] { "", "[" }/* No.17 :ɒ`܂B */, new string[] { "", "]" }/* No.18 :ɒ`܂B */, new string[] { "", "_" }/* No.19 :ɒ`܂B */, new string[] { "", "a" }/* No.20 :ɒ`܂B */, new string[] { "", "d" }/* No.21 :ɒ`܂B */, new string[] { "", "f" }/* No.22 :ɒ`܂B */, new string[] { "", "h" }/* No.23 :ɒ`܂B */, new string[] { "", "o" }/* No.24 :ɒ`܂B */, new string[] { "", "r" }/* No.25 :ɒ`܂B */, new string[] { "", "u" }/* No.26 :ɒ`܂B */, new string[] { "", "x" }/* No.27 :ɒ`܂B */, new string[] { "", "{" }/* No.28 :ɒ`܂B */, new string[] { "", "p" }/* No.29 :ɒ`܂B */, new string[] { "", "s" }/* No.30 :ɒ`܂B */, new string[] { "", "v" }/* No.31 :ɒ`܂B */, new string[] { "", "y" }/* No.32 :ɒ`܂B */, new string[] { "", "|" }/* No.33 :ɒ`܂B */, new string[] { "", "@" }/* No.34 :a7: J^JiB@B */, new string[] { "", "B" }/* No.35 :a8: J^Ji */, new string[] { "", "D" }/* No.36 :a9: J^Ji */, new string[] { "", "F" }/* No.37 :aa: J^Ji */, new string[] { "", "H" }/* No.38 :ab: J^Ji */, new string[] { "", "" }/* No.39 :ac: J^Ji */, new string[] { "", "" }/* No.40 :ad: J^Ji */, new string[] { "", "" }/* No.41 :ae: J^JiBB */, new string[] { "", "b" }/* No.42 :af: J^JiBbB̎ɒ`Ă܂B */, new string[] { "", "[" }/* No.43 :b0: p̐L΂BSpJ^Jił͂ȂAL΂u[vɕϊB */, new string[] { "", "A" }/* No.44 :b1: J^JiBAB */, new string[] { "", "C" }/* No.45 :b2: J^Ji */, new string[] { "", "E" }/* No.46 :b3: J^Ji */, new string[] { "", "G" }/* No.47 :b4: J^Ji */, new string[] { "", "I" }/* No.48 :b5: J^Ji */, new string[] { "", "J" }/* No.49 :b6: J^Ji */, new string[] { "", "L" }/* No.50 :b7: J^Ji */, new string[] { "", "N" }/* No.51 :b8: J^Ji */, new string[] { "", "P" }/* No.52 :b9: J^Ji */, new string[] { "", "R" }/* No.53 :ba: J^Ji */, new string[] { "", "T" }/* No.54 :bb: J^Ji */, new string[] { "", "V" }/* No.55 :bc: J^Ji */, new string[] { "", "X" }/* No.56 :bd: J^Ji */, new string[] { "", "Z" }/* No.57 :be: J^Ji */, new string[] { "", "\" }/* No.58 :bf: J^Ji */, new string[] { "", "^" }/* No.59 :c0: J^Ji */, new string[] { "", "`" }/* No.60 :c1: J^Ji */, new string[] { "", "c" }/* No.61 :c2: J^Ji */, new string[] { "", "e" }/* No.62 :c3: J^Ji */, new string[] { "", "g" }/* No.63 :c4: J^Ji */, new string[] { "", "i" }/* No.64 :c5: J^Ji */, new string[] { "", "j" }/* No.65 :c6: J^Ji */, new string[] { "", "k" }/* No.66 :c7: J^Ji */, new string[] { "", "l" }/* No.67 :c8: J^Ji */, new string[] { "", "m" }/* No.68 :c9: J^Ji */, new string[] { "", "n" }/* No.69 :ca: J^Ji */, new string[] { "", "q" }/* No.70 :cb: J^Ji */, new string[] { "", "t" }/* No.71 :cc: J^Ji */, new string[] { "", "w" }/* No.72 :cd: J^Ji */, new string[] { "", "z" }/* No.73 :ce: J^Ji */, new string[] { "", "}" }/* No.74 :cf: J^Ji */, new string[] { "", "~" }/* No.75 :d0: J^Ji */, new string[] { "", "" }/* No.76 :d1: J^Ji */, new string[] { "", "" }/* No.77 :d2: J^Ji */, new string[] { "", "" }/* No.78 :d3: J^Ji */, new string[] { "", "" }/* No.79 :d4: J^Ji */, new string[] { "", "" }/* No.80 :d5: J^Ji */, new string[] { "", "" }/* No.81 :d6: J^Ji */, new string[] { "", "" }/* No.82 :d7: J^Ji */, new string[] { "", "" }/* No.83 :d8: J^Ji */, new string[] { "", "" }/* No.84 :d9: J^Ji */, new string[] { "", "" }/* No.85 :da: J^Ji */, new string[] { "", "" }/* No.86 :db: J^Ji */, new string[] { "", "" }/* No.87 :dc: J^JiBB */, new string[] { "", "" }/* No.88 :a6: J^JiBBMS932ɂR[hƂĂ AOɈʒu܂B */, new string[] { "", "" }/* No.89 :dd: J^JiBB */, new string[] { "", "J" }/* No.90 :de: BSpJ^Jił͂ȂlɕϊB */, new string[] { "", "K" }/* No.91 :df: BSpJ^Jił͂ȂlɕϊB */ };

        /// <summary>ϊ`ɏ]Aϊ܂B</summary>
        /// <param name="argCheck">ϊΏۂ̕B</param>
        /// <returns>ϊ`ɂĕϊꂽBϊ`ɂЂƂvȂꍇɂ͌̕񂪖߂܂B</returns>
        public virtual string Convert(string argCheck)
        {
            if (argCheck == null) {
                throw new ArgumentException("\bh[Convert]̃p[^[argCheck]null^܂BÃp[^null^邱Ƃ͂ł܂B");
            }

            string wrkString = "";
            for (int index = 0; index < argCheck.Length; ) {
                string look = argCheck.Substring(index);
                bool isFound = false;
                for (int indexDef = 0; indexDef < STRING_CONVERT_DEF.Length; indexDef++) {
                    string wrkStrComp = look;
                    if (look.Length > STRING_CONVERT_DEF[indexDef][0].Length) {
                        wrkStrComp = wrkStrComp.Substring(0, STRING_CONVERT_DEF[indexDef][0].Length);
                    }
                    if (STRING_CONVERT_DEF[indexDef][0].Equals(wrkStrComp)) {
                        wrkString += STRING_CONVERT_DEF[indexDef][1];
                        index += STRING_CONVERT_DEF[indexDef][0].Length;
                        isFound = true;
                        break;
                    }
                }
                if (!isFound) {
                    wrkString += argCheck.Substring(index, 1);
                    index = index + 1;
                }
            }

            return wrkString;
        }
    }
}
